<template>
   <div>
      <button @click="ToggleShow" class="btn-show">{{showGrid ? 'Hide' : 'Show'}} Grid</button>
      <div class="Image-input">
         <!--<label class="Image-input__input-wrapper" for="upload">-->
            <!--Choose-->
            <!--<input @change="previewThumbnail" class="Image-input__input" name="thumbnail" type="file" id="upload">-->
         <!--</label>-->
         <!--<div v-if="imageSrc" class="btn-zoom" @click="zoomMore">+</div>-->
         <!--<div v-if="imageSrc" class="btn-zoom" @click="zoomLess">-</div>-->
         <div class="Image-input__image-wrapper">
            <i v-show="! imageSrc" class="icon fa fa-picture-o"></i>
            <img v-show="imageSrc" class="Image-input__image" src="/static/img/photo.jpg" :style="'transform: scale('+scale+');'">
            <Grid class-name="my-class" v-show="showGrid" :steps="steps" :status="status" :colorRobot="colorRobot"/>
         </div>
      </div>
      <Robots @setColorRobot="setColorRobot" @stepsRobot="stepsRobot" :status="status" :grid="grid"/>
      <BtnControl @changeStatus="changeStatus"/>
      <div class="modal" v-if="showModal">
         <div class="modal-container" :style="'background-color:'+color+';}'">
            <div @click="close" class="btn-close">X</div>
            <p>{{this.steps >= this.grid ? 'success!' : 'Sorry, please try again.'}}</p>
         </div>
      </div>
   </div>
</template>

<script>
    import Grid from '@/components/Grid'
    import BtnControl from '@/components/BtnControl'
    import Robots from '@/components/Robots'
    export default {
        name: "ImageInput",
        components: {
            Grid,
            BtnControl,
            Robots
        },
        data: function () {
            return {
                scale: 1,
                showGrid: false,
                steps: '0',
                status: false,
                showModal: false,
                grid: 12,
                color: '',
                colorRobot: '',
                imageSrc: ''
            }},
        // props: [ 'imageSrc' ],
        methods: {
            changeStatus: function(status) {
                this.status = status;
                this.showGrid = true;
            },
            stepsRobot: function(steps){
                this.steps = steps;
            },
            setGrid(setGrid){
                this.grid = setGrid;
            },
            setColorRobot(colorRobot){
                this.colorRobot = colorRobot;
            },
            previewThumbnail: function(event) {
                var input = event.target;

                if (input.files && input.files[0]) {
                    var reader = new FileReader();
                    var vm = this;

                    reader.onload = function(e) {
                        vm.imageSrc = e.target.result;
                    }

                    reader.readAsDataURL(input.files[0]);
                }
            },
            zoomMore(){
                if(this.scale < 3){
                    this.scale = this.scale + 0.5;
                }
            },
            zoomLess(){
                if(this.scale > 1){
                    this.scale = this.scale - 0.5;

                }
            },
            ToggleShow(){
                this.showGrid = !this.showGrid;
            },
            close(){
                this.showModal = false;
            }
        },
        watch:{
            status: function(){
                let showMessage = 0;
                if(this.status){
                    this.grid < this.steps ? this.color = 'green' : this.color = 'red';
                    this.grid < this.steps ? showMessage = Number(this.grid*1110) : showMessage = Number(this.steps*1110);
                    setTimeout(() =>{
                        this.showModal = true;
                        this.status = false;
                    }, showMessage);
                }
            }
        },
    }
</script>

<style scoped>
   .Image-input {
   }

   .Image-input__image-wrapper {
      max-width: 600px;
      /*min-height: 480px;*/
      height: 480px;
      margin: 0px auto;
      display: flex;
      align-items: center;
      justify-content: center;
      overflow: hidden;
   }

   .Image-input__image {
      /*max-width: 100%;*/
      width: 100%;
      border-radius: 1px;
      display: block !important;
   }

   .Image-input__input-wrapper {
      background: #eee;
      display: inline-block;
      border-radius: 10px;
      position: relative;
      cursor: pointer;
      padding: 10px 20px;
   }

   .Image-input__input-wrapper:hover {
      background: #e0e0e0;
   }
   .Image-input__input {
      display: none;
   }
   .btn-zoom{
      background-color: grey;
      width: 30px;
      height: 30px;
      color: #fff;
      font-size: 20px;
      border-radius: 100%;
      display: flex;
      justify-content: center;
      align-items: center;
      margin: 10px;
      cursor: pointer;
      position: absolute;
   }
   .btn-zoom:nth-of-type(2){
      margin-top: 50px;
   }
   .btn-zoom:hover{
      background-color: blue;
   }
   .btn-show{
      background-color: blue;
      color: #fff;
      padding: 7px 20px;
      border-radius: 5px;
      border: none;
      cursor: pointer;
   }
   .btn-show:hover{
      background-color: #0404ae;
   }
   .modal{
      position: fixed;
      background-color: rgba(0,0,0, 0.2);
      width: 100%;
      height: 100%;
      top: 0;
      left: 0;
   }
   .modal-container{
      width: 100%;
      max-width: 300px;
      padding: 20px 80px;
      position: absolute;
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%);
   }
   .modal-container p{
      color: #fff;
      font-size: 30px;
      text-align: center;
      text-transform: uppercase;
   }
   .modal-container .btn-close{
   position: absolute;
      color: #fff;
      border: 2px solid #fff;
      border-radius: 100%;
      display: flex;
      justify-content: center;
      align-items: center;
      width: 20px;
      height: 20px;
      top: -20px;
      right: -20px;
      cursor: pointer;
   }
</style>